#Enquist, Ghirlanda & Lind:  The Human Evolutionary Transition
#Program for figure 5.6 - Chapter 5 Sources of information
from math import exp
import matplotlib.pyplot as plt
from random import seed,random, randrange, choice
seed()


def memory_update(B, alpha_I, alpha_II, vI, vII):
    u = current_patch_reward[B]
    vI[B]  = vI[B]  + alpha_I*(u-vI[B])
    vII[B] = vII[B] + alpha_II*(u-vII[B])


def decision(vI, vII): 
    beta = 1.5
    z=[]
    for i in range(patches): z.append(exp(beta*(vI[i] + vII[i])))
    q=random()*sum(z)
    B=0
    while q>sum(z[0:B+1]): B+=1
    return B


def patch_update(): #Changes where food can be found
    for i in range(useful_patches):
        if random()<0.1:
            if current_patch_reward[i] == reward: current_patch_reward[i]=0
            else: current_patch_reward[i] = reward


def simulate(alpha_II):
    # alpha_I is the slow memory
    # alpha_II is the fast memory. Set to 0 in the one memory case
    reward_data = []
    for alpha_I in learning_rates:
        n=0
        for repeat in range(repeats):
            vI,vII = patches*[0],patches*[0]
            for i in range(useful_patches): current_patch_reward[i]=choice([0,reward])  
            for trial in range(1,number_of_trials+1):
                B = decision(vI, vII)
                memory_update(B, alpha_I, alpha_II, vI, vII)
                if current_patch_reward[B]==reward: n += 1
                patch_update()
        reward_data.append( float(n)/(number_of_trials*repeats) )
    return reward_data


#-------------------------------------------------------------------------
patches = 100 
useful_patches = 5 #patches were food can potentially be found
current_patch_reward =patches*[0] 
reward = 5 
number_of_trials = 5000
repeats = 20
learning_rates = [i*0.025 for i in range(41) ]

# With fast memory
reward_data = simulate(1)
plt.plot(learning_rates, reward_data, label='Two memories')
# No fast memory
reward_data = simulate(0)
plt.plot(learning_rates, reward_data, label='One memory')

plt.ylim(0, 0.75)
plt.ylabel('Reward rate')
plt.xlabel('Learning rate (slow memory)')
plt.legend()
plt.show()
